<?php

namespace Wp618\Com\BaiduAi;

use function Wp618Com\aff9e7\is_admin_user;

if ( !defined( 'ABSPATH' ) ) exit;

//
class Action{
    private $app;
    private $start_time = 0;
    private $log_id = 0;

    //
    public function __construct(){
        $this->app = App::getInstance();

        add_action('init', [$this, 'add_log']);
    }

    public function add_log(){
        if(is_admin()){
            return false;
        }

        $ip = $_SERVER['REMOTE_ADDR'];
        $row = $this->app->ip_model->get_one([
            'where' => ['ip' => $ip],
        ]);
        if(empty($row)){
            return false;
        }

        $this->start_time = microtime(true);

        $ip = $_SERVER['REMOTE_ADDR'];
        $lang = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? strip_tags($_SERVER['HTTP_ACCEPT_LANGUAGE']) : '-';
        $ua = isset($_SERVER['HTTP_USER_AGENT']) ? strip_tags($_SERVER['HTTP_USER_AGENT']) : '-';
        $ua = mb_substr($ua, 0, 255, 'utf-8');
        $referer = isset($_SERVER['HTTP_REFERER']) ? strip_tags($_SERVER['HTTP_REFERER']) : '-';
        $referer = mb_substr($referer, 0, 255, 'utf-8');

        $this->log_id = $this->app->visitor_model->insert([
            'ip' => $ip,
            'username' => '',
            'request_method' => strtolower($_SERVER['REQUEST_METHOD']),
            'lang' => $lang,
            'ua' => $ua,
            'url' => $_SERVER['REQUEST_URI'],
            'location' => '-',
            'page_type' => '-',
            'time_ms' => 0,
            'referer' => $referer,
            'user_id' => (int) get_current_user_id(),
        ]);

        $this->delete_more_data();

        wp_die('Sorry, the page you are looking for does not exist.(1)');
    }

    //
    public function update_log(){


    }

    //
    private function delete_more_data(){
//        $max = get_config_value('general.max_count');
        if(empty($max)){
            $max = 10000;
        }

        $row_max = $this->app->visitor_model->get_one([
            'order' => 'id desc',
        ]);

        if(empty($row_max)){
            return false;
        }

        for($i = 0; $i < 10; $i++){
            $row_min = $this->app->visitor_model->get_one([
                'order' => 'id asc',
            ]);

            if(empty($row_min)){
                return false;
            }

            if(($row_max['id'] - $row_min['id']) >= $max){
                $this->app->visitor_model->delete(['id' => $row_min['id']]);
            }else{
                break;
            }
        }

        return true;
    }

}
