<?php

namespace Wp618\Com\BaiduAi;

if ( !defined( 'ABSPATH' ) ) exit;

//
class Time
{
    //
    public function wp_strtotime($str){
        if(function_exists('wp_timezone_string')){
            $dt = wp_timezone_string();
        }else{
            $dt = $this->get_db_timezone();
        }

        $date = new \DateTimeImmutable($str, new \DateTimeZone($dt));
        return $date->format('U');
    }

    //
    public function wp_date($format, $timestamp){
        if(function_exists('\wp_date')){
            return \wp_date($format, $timestamp);
        }

        if(function_exists('wp_timezone_string')){
            $dt = \wp_timezone_string();
        }else{
            $dt = $this->get_db_timezone();
        }

        $date = new \DateTime();
        $date->setTimezone(new \DateTimeZone($dt));
        $date->setTimestamp($timestamp);
        return $date->format($format);
    }

    //
    private function get_db_timezone(){
        $tz = (string) get_option('timezone_string');
        if(strlen($tz) < 1){
            $tz = 'UTC';
        }

        return $tz;
    }

}