<?php

namespace Wp618\Com\BaiduAi;

if ( !defined( 'ABSPATH' ) ) exit;

//
class Menu
{
    const PAGE_TITLE = '百度 AI';
    // https://developer.wordpress.org/resource/dashicons/
    const MENU_ICON = 'dashicons-universal-access-alt';

    private $app;

    //
    public function __construct(){
        $this->app = App::getInstance();

        \add_action('admin_menu', [$this, 'set_menu']);
    }

    //
    public function set_menu()
    {
        $parent_slug = strtolower(str_replace('\\', '_', __CLASS__));
        $is_actived = $this->app->get_is_actived();

        $title = $menu_title = self::PAGE_TITLE;

        add_menu_page(
            $title,
            $menu_title,
            'manage_options',
            $parent_slug,
            [$this->app->setup, 'load_setup'],
            self::MENU_ICON,
            100
        );

        if($is_actived){
            add_submenu_page(
                $parent_slug,
                '使用 AI',
                '使用 AI',
                'manage_options',
                $this->get_sub_slug(__LINE__),
                [$this->app->setup, 'apply_baidu_ai']
            );
//            add_submenu_page(
//                $parent_slug,
//                'IP 列表',
//                'IP 列表',
//                'manage_options',
//                $this->get_sub_slug(__LINE__),
//                [$this->app->setup, 'loglog']
//            );
//            add_submenu_page(
//                $parent_slug,
//                '被拒记录',
//                '被拒记录',
//                'manage_options',
//                $this->get_sub_slug(__LINE__),
//                [$this->app->setup, 'ban_log']
//            );
        }
    }

    //
    private function get_sub_slug($num){
        $slug = strtolower(str_replace('\\', '_', __CLASS__));

        return $slug . '_' . substr(md5($num), -8);
    }

}
