<?php

namespace Wp618\Com\BaiduAi;

if ( !defined( 'ABSPATH' ) ) exit;

//
class Posts_model extends Model
{
    protected $table = 'posts';
    protected $is_dev_table = false;

    //
    public function get_like_list($num = 10){
        $kv = $this->app->commentmeta_model->get_like_post_id_list();

        return $this->get_rank_list($kv, $num);
    }

    //
    public function get_hot_list($num = 10){
        $kv = $this->app->commentmeta_model->get_hot_post_id_list();

        return $this->get_rank_list($kv, $num);
    }

    //
    public function get_rank_list($rank_kv, $num = 10){
        arsort($rank_kv);

        $post_id_arr = array_keys(array_slice($rank_kv, 0, $num * 2, true));

        $query = [
            'columns' => 'ID, post_title, post_type, post_date',
            'where' => [
                'post_status' => 'publish',
                'post_type' => 'post',
            ],
            'where_in' => [
                'ID%d' => $post_id_arr,
            ],
            'order' => 'ID desc',
            'limit' => $num,
        ];

        $list = $this->app->posts_model->get_all($query);

        $list = $this->app->themeDataset->add_post_fields($list);

        $ls = [];

        foreach ($rank_kv as $post_id => $null){
            if(isset($list[$post_id])){
                $ls[] = $list[$post_id];
            }

            if(count($ls) >= $num){
                break;
            }
        }

        return $ls;
    }

    //
    public function get_rand_list($num = 10){
        $hot_kv = $this->app->commentmeta_model->get_hot_post_id_list();

        $post_id_arr = array_keys($hot_kv);
        shuffle($post_id_arr);
        $post_id_arr = array_slice($post_id_arr, 0, $num);

        $query = [
            'columns' => 'ID, post_title, post_type, post_date',
            'where' => [
                'post_status' => 'publish',
                'post_type' => 'post',
            ],
            'where_in' => [
                'ID%d' => $post_id_arr,
            ],
            'order' => 'ID desc',
            'limit' => $num,
        ];

        $list = $this->app->posts_model->get_all($query);

        $list = $this->app->themeDataset->add_post_fields($list);

        shuffle($list);

        return $list;
    }

    //
    public function get_related_list($num = 4){
        $term_id_arr = [];

        $terms = get_the_tags();
        if(empty($tags)){
            $terms = get_the_category();
        }

        if(empty($terms)){
            return [];
        }

        foreach ($terms as $term){
            $term_id_arr[] = $term->term_id;
        }

        $post_id_arr = $this->app->termship_model->get_term_map_post_id_arr($term_id_arr);

        $query = [
            'columns' => 'ID, post_title, post_type, post_date',
            'where' => [
                'post_status' => 'publish',
                'post_type' => 'post',
            ],
            'where_in' => [
                'ID%d' => $post_id_arr,
            ],
            'order' => 'ID desc',
            'limit' => $num * 5,
        ];

        $list = $this->app->posts_model->get_all($query);

        $list = $this->app->themeDataset->add_post_fields($list);

        shuffle($list);

        return array_slice($list, 0, $num);
    }

    //
    public function get_site_posts($num = 1000){
        $query = [
            'columns' => 'ID, ID as id, post_title, post_title as title, post_type, post_date, post_modified',
            'where' => [
                'post_status' => 'publish',
                'post_type' => 'post',
            ],
            'order' => 'ID desc',
            'limit' => $num,
        ];

        return $this->app->posts_model->get_all($query);
    }

}