<?php
namespace Wp618\Com\BaiduAi;
?>

<div class="wrap">
    <h1>IP 列表</h1>
    <hr class="wp-header-end">

    <style>
        span[data-type]{
            cursor: pointer;
        }
    </style>

    <form id="posts-filter" method="get">
        <?php
        foreach ($_GET as $key => $val){
            if($key == 'paged'){
                continue;
            }
            echo '<input type="hidden" name="' . esc_attr($key) . '" value="' . esc_attr($val) . '">';
        }
        ?>
        <div class="tablenav top">
            <div class="alignleft actions bulkactions">
                <input type="hidden" name="action" value="<?php echo $action; ?>">
                <input type="hidden" name="delete_action" value="<?php echo $delete_action; ?>">
                <input type="hidden" name="nonce" value="<?php echo $nonce; ?>">
                <input type="button" id="j-delete-all" class="button action" value="清空 IP">
            </div>

            <p style="margin: 0;">
                <label class="screen-reader-text" for="post-search-input">搜索 IP:</label>
                <input type="search" id="post-search-input" name="ip" value="">
                <input type="submit" id="search-submit" class="button" value="搜索 IP">
            </p>

            <?php
            $paging->render('top');
            ?>
            <br class="clear">
        </div>

        <table class="wp-list-table widefat fixed striped table-view-list pages">
            <thead>
            <tr>
                <th scope="col" class="manage-column column-primary desc" style="width:50px">
                    <strong>ID</strong>
                </th>
                <th scope="col" class="manage-column">
                    <strong>IP</strong>
                </th>
                <th scope="col" class="manage-column">
                    <strong>时间</strong>
                </th>
                <th scope="col" class="manage-column asc">
                    <strong>操作</strong>
                </th>
            </tr>
            </thead>

            <tbody id="the-list">
            <?php
            foreach ($list as $item){
                ?>
                <tr class="iedit author-self level-0 post-2 type-page status-publish hentry">
                    <td class="title column-title has-row-actions column-primary">
                        <?php echo $item['id']; ?>
                    </td>
                    <td class="author">
                        <?php echo esc_html($item['ip']); ?>
                    </td>
                    <td class="author">
                        <?php echo esc_html($item['uptime']); ?>
                    </td>
                    <td class="date">
                        <input type="button" style="border-color:red" data-id="<?php echo $item['id']; ?>"
                               class="button button-link-delete" value="删除">
                    </td>
                </tr>
                <?php
            }
            ?>
            </tbody>
        </table>
        <div class="tablenav bottom">
            <?php
            $paging->render('bottom');
            ?>
            <br class="clear">
        </div>
    </form>
</div>

<script>
    jQuery(function ($) {
        //
        $('#j-delete-all').click(function (){
            let data = {
                action: $('input[name="delete_action"]').val(),
                nonce: $('input[name="nonce"]').val(),
            };

            $.post(ajaxurl, data, function(res){
                if(res.success){
                    $('#the-list tr').remove();
                }
            }, 'json');
        });

        //
        $('.button-link-delete').click(function (){
            let data = {
                action: $('input[name="delete_action"]').val(),
                nonce: $('input[name="nonce"]').val(),
                id: $(this).data('id')
            };

            let $that = $(this);

            $.post(ajaxurl, data, function(res){
                if(res.success){
                    $that.parents('tr').remove();
                }
            }, 'json');
        });
    });
</script>